(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["./scene.js"], factory);
  } else if (typeof exports !== "undefined") {
    factory(require("./scene.js"));
  } else {
    var mod = {
      exports: {}
    };
    factory(global.scene);
    global.offscreen = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_scene) {
  "use strict";

  _scene = _interopRequireDefault(_scene);

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

  self.onmessage = function (message) {
    var data = message.data;
    (0, _scene.default)(data.drawingSurface, data.width, data.height, data.pixelRatio, data.path);
  };
});
