(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.NodeFunction = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var NodeFunction = /*#__PURE__*/function () {
    function NodeFunction(type, inputs) {
      var name = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
      var presicion = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '';

      _classCallCheck(this, NodeFunction);

      this.type = type;
      this.inputs = inputs;
      this.name = name;
      this.presicion = presicion;
    }

    _createClass(NodeFunction, [{
      key: "getCode",
      value: function
        /*name = this.name*/
      getCode() {
        console.warn('Abstract function.');
      }
    }]);

    return NodeFunction;
  }();

  NodeFunction.isNodeFunction = true;
  var _default = NodeFunction;
  _exports.default = _default;
});
