(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.NodeUniform = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

  var NodeUniform = /*#__PURE__*/function () {
    function NodeUniform(name, type, node) {
      var needsUpdate = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;

      _classCallCheck(this, NodeUniform);

      this.name = name;
      this.type = type;
      this.node = node;
      this.needsUpdate = needsUpdate;
    }

    _createClass(NodeUniform, [{
      key: "value",
      get: function get() {
        return this.node.value;
      },
      set: function set(val) {
        this.node.value = val;
      }
    }]);

    return NodeUniform;
  }();

  NodeUniform.prototype.isNodeUniform = true;
  var _default = NodeUniform;
  _exports.default = _default;
});
